<?php

namespace Drupal\mortgage_calculator\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

class MortgageCalculatorForm extends FormBase {

  public function getFormID() {
    return 'mortgage_calculator_form';
  }

  public function buildForm(array $form, FormStateInterface $form_state) {

    $form['mortgage_calculator_loan_amount'] = array(
      '#type' => 'textfield',
      '#title' => $this->t('Price of Home'),
      '#default_value' => \Drupal::state()->get('mortgage_calculator_loan_amount'),
      '#size' => 10,
      '#maxlength' => 64,
  //    '#description' => $this->t(''),
    );
    $form['mortgage_calculator_mortgage_rate'] = array(
      '#type' => 'textfield',
      '#title' => $this->t('Mortgage Rate'),
      '#default_value' => \Drupal::state()->get('mortgage_calculator_mortgage_rate'),
      '#size' => 10,
      '#maxlength' => 64,
  //    '#description' => $this->t(''),
    );
    $form['mortgage_calculator_years_to_pay'] = array(
      '#type' => 'textfield',
      '#title' => $this->t('Years to Pay'),
      '#default_value' => \Drupal::state()->get('mortgage_calculator_years_to_pay'),
      '#size' => 10,
      '#maxlength' => 64,
  //    '#description' => $this->t(''),
    );
    $form['mortgage_calculator_desired_display'] = array(
      '#type' => 'select',
      '#title' => $this->t('Desired table display'),
      '#default_value' => \Drupal::state()->get('mortgage_calculator_desired_display'),
      '#options' => array('monthly' => $this->t('monthly'), 'yearly' => $this->t('yearly')),
      '#description' => $this->t(''),
    );
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => $this->t('Calculate')
    );

    return $form;
  }

  public function validateForm(array &$form, FormStateInterface $form_state) {
    if ($form_state->getValue('mortgage_calculator_years_to_pay') == '' || $form_state->getValue('mortgage_calculator_years_to_pay') <= 0) {
      $form_state->setErrorByName('mortgage_calculator_years_to_pay', $this->t('Please enter a value of years to pay.'));
    }
  }

  public function submitForm(array &$form, FormStateInterface $form_state) {

    \Drupal::state()->set('mortgage_calculator_loan_amount', $form_state->getValue('mortgage_calculator_loan_amount'));
    \Drupal::state()->set('mortgage_calculator_mortgage_rate', $form_state->getValue('mortgage_calculator_mortgage_rate'));
    \Drupal::state()->set('mortgage_calculator_years_to_pay', $form_state->getValue('mortgage_calculator_years_to_pay'));
    \Drupal::state()->set('mortgage_calculator_desired_display', $form_state->getValue('mortgage_calculator_desired_display'));

    $form_state->setRedirect('mortgage_calculator.page');
  }
}

